/**
 * 
 * @author 
 * 
 * Description: 
 *
 */

public class Vehicle
{
    /***** YOUR CODE HERE - INSTANCE VARIABLES *****/
           

	/**
	 * Constructor
	 * 
	 * @param make
	 * @param model
	 * @param passengers
	 * @param mpg
	 * @param price
	 */
	public Vehicle(String make, String model, int passengers, double mpg, int price)
    {
        /***** YOUR CODE HERE *****/
    }
   
	/**
	 * Return the price of this make and model vehicle.
	 * 
	 * @return
	 */
    public int getPrice()
    {
        /***** YOUR CODE HERE *****/
        return 0;
    }
    
    /**
     * Return the passenger miles per gallon (PMPG) of this vehicle.
     * PMPG is a metric to evaluate the energy efficiency of a vehicle or transportation mode.
     * The PMPG can be obtained by multiplying the miles per gallon of fuel (MPG) by the passenger capacity.
     * 
     * @return
     */
    public double getPassengerMilesPerGallon()
    {
        /***** YOUR CODE HERE *****/
        return 0.0;
    }
        
    /**
     * Return a string representation of this vehicle, decimals rounded to one place.
     * Example output:
     * "Hummer H3, 5 passengers, MPG 14.0, PMPG 70.0, $32300"
     * 
     * @ return
     */
    public String toString()
    {
        /***** YOUR CODE HERE *****/
        return "";
    }
        
    /**
     * Returns the name of this vehicle, that is the make and model.
     * Example:
     *  "Hummer H3"
     * 
     * @return
     */
    public String getMakeModel()
    {
        /***** YOUR CODE HERE *****/
        return "";
    }
    
    /**
     * Check if this Vehicle is a particular make.
     * This check is *case insensitive*, so returns true for a vehicle 
     * with make "Toyota" if called with "toyota", "Toyota", "TOYOTA", ...
     * 
     * @param make
     * @return
     */
    public boolean isSameMake(String make)
    {
        /***** YOUR CODE HERE *****/
        return false;
    }
    
    /**
     * Calculate how much it would cost to drive this vehicle a certain number of miles.
     * Calling code tells us how much gas costs per gallon.
     * 
     * @param miles
     * @param pricePerGallon
     * @return
     */
    public double costToDriveDistance(double miles, double pricePerGallon)
    {
        /***** YOUR CODE HERE *****/
        return 0.0;
    }
    
    /**
     * Test main, reference output:
     *   Hummer H3, 5 passengers, MPG 14.0, PMPG 70.0, $32300
     *   Toyota Prius, 5 passengers, MPG 50.0, PMPG 250.0, $30395
     *   Toyota Avalon, 5 passengers, MPG 25.0, PMPG 125.0, $39650
     *   Ford E350_Super_Duty_Extended, 15 passengers, MPG 11.0, PMPG 165.0, $36545
     *
     *   Assuming gas costs $3.79 per gallon, cost to travel 123 miles:
     *   Hummer H3 = $33.30
     *   Toyota Prius = $9.32
     *   Toyota Avalon = $18.65
     *   Ford E350_Super_Duty_Extended = $42.38
     *
     *   Toyota Prius, 5 passengers, MPG 50.0, PMPG 250.0, $30395
     *   Toyota Avalon, 5 passengers, MPG 25.0, PMPG 125.0, $39650
     *
     *   Hummer H3, 5 passengers, MPG 14.0, PMPG 70.0, $32300
     * 
     * @param args
     */
    public static void main(String [] args)
    {
        Vehicle [] vehicles = new Vehicle[4];
        
        Vehicle hummer = new Vehicle("Hummer", "H3", 5, 14.0, 32300);
        vehicles[0] = hummer;

        Vehicle prius = new Vehicle("Toyota", "Prius", 5, 50.0, 30395);
        vehicles[1] = prius;
                
        Vehicle avalon = new Vehicle("Toyota", "Avalon", 5, 25.0, 39650);
        vehicles[2] = avalon;
        
        Vehicle e350 = new Vehicle("Ford", "E350_Super_Duty_Extended", 15, 11.0, 36545);
        vehicles[3] = e350;

        // Print out a full description of each vehicle
        for (Vehicle v : vehicles)
            System.out.println(v);        
        System.out.println();
        
        // Print out how much it costs to drive each one a certain distance with a certain cost for gas
        final int DISTANCE = 123;
        final double PRICE_PER_GALLON = 3.79;
        System.out.printf("Assuming gas costs $%.2f per gallon, cost to travel %d miles:\n", PRICE_PER_GALLON, DISTANCE);
        
        for (Vehicle v : vehicles)
            System.out.printf("%s = $%.2f\n", v.getMakeModel(), v.costToDriveDistance(DISTANCE, PRICE_PER_GALLON));
        System.out.println();
        
        // Just print out the details of a certain make of vehicle
        final String MAKE = "Toyota";
        for (Vehicle v : vehicles)
        {
            if (v.isSameMake(MAKE))
                System.out.println(v);
        }
        System.out.println();
        
        // Just print out the details of a certain make of vehicle
        final String MAKE2 = "HUMMER";
        for (Vehicle v : vehicles)
        {
            if (v.isSameMake(MAKE2))
                System.out.println(v);
        }
        
    }   
    
}
